require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_IA64_DMA_MAPPING_H)) {
    eval 'sub _ASM_IA64_DMA_MAPPING_H () {1;}' unless defined(&_ASM_IA64_DMA_MAPPING_H);
    require 'asm/machvec.ph';
    eval 'sub dma_alloc_coherent () { &platform_dma_alloc_coherent;}' unless defined(&dma_alloc_coherent);
    eval 'sub dma_alloc_noncoherent () { &platform_dma_alloc_coherent;}' unless defined(&dma_alloc_noncoherent);
    eval 'sub dma_free_coherent () { &platform_dma_free_coherent;}' unless defined(&dma_free_coherent);
    eval 'sub dma_free_noncoherent () { &platform_dma_free_coherent;}' unless defined(&dma_free_noncoherent);
    eval 'sub dma_map_single () { &platform_dma_map_single;}' unless defined(&dma_map_single);
    eval 'sub dma_map_sg () { &platform_dma_map_sg;}' unless defined(&dma_map_sg);
    eval 'sub dma_unmap_single () { &platform_dma_unmap_single;}' unless defined(&dma_unmap_single);
    eval 'sub dma_unmap_sg () { &platform_dma_unmap_sg;}' unless defined(&dma_unmap_sg);
    eval 'sub dma_sync_single_for_cpu () { &platform_dma_sync_single_for_cpu;}' unless defined(&dma_sync_single_for_cpu);
    eval 'sub dma_sync_sg_for_cpu () { &platform_dma_sync_sg_for_cpu;}' unless defined(&dma_sync_sg_for_cpu);
    eval 'sub dma_sync_single_for_device () { &platform_dma_sync_single_for_device;}' unless defined(&dma_sync_single_for_device);
    eval 'sub dma_sync_sg_for_device () { &platform_dma_sync_sg_for_device;}' unless defined(&dma_sync_sg_for_device);
    eval 'sub dma_mapping_error () { &platform_dma_mapping_error;}' unless defined(&dma_mapping_error);
    eval 'sub dma_map_page {
        local($dev, $pg, $off, $size, $dir) = @_;
	    eval q( &dma_map_single($dev,  &page_address($pg) + ($off), ($size), ($dir)));
    }' unless defined(&dma_map_page);
    eval 'sub dma_unmap_page {
        local($dev, $dma_addr, $size, $dir) = @_;
	    eval q( &dma_unmap_single($dev, $dma_addr, $size, $dir));
    }' unless defined(&dma_unmap_page);
    eval 'sub dma_sync_single_range_for_cpu {
        local($dev, $dma_handle, $offset, $size, $dir) = @_;
	    eval q( &dma_sync_single_for_cpu($dev, $dma_handle, $size, $dir));
    }' unless defined(&dma_sync_single_range_for_cpu);
    eval 'sub dma_sync_single_range_for_device {
        local($dev, $dma_handle, $offset, $size, $dir) = @_;
	    eval q( &dma_sync_single_for_device($dev, $dma_handle, $size, $dir));
    }' unless defined(&dma_sync_single_range_for_device);
    eval 'sub dma_supported () { &platform_dma_supported;}' unless defined(&dma_supported);
    eval 'sub dma_set_mask {
        local($dev,$mask) = @_;
	    eval q({  &if (! ($dev->{dma_mask}) || ! &dma_supported($dev, $mask)) - &EIO; * ($dev->{dma_mask}) = $mask; 0; });
    }' unless defined(&dma_set_mask);
    eval 'sub dma_get_cache_alignment {
        local($void) = @_;
	    eval q({ \'int\'  &ia64_max_cacheline_size;  &ia64_max_cacheline_size; });
    }' unless defined(&dma_get_cache_alignment);
    eval 'sub dma_cache_sync {
        local($vaddr,$size,$dir) = @_;
	    eval q({  &mb(); });
    }' unless defined(&dma_cache_sync);
    eval 'sub dma_is_consistent {
        local($dma_handle) = @_;
	    eval q((1));
    }' unless defined(&dma_is_consistent);
}
1;
