require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_IA64_IO_H)) {
    eval 'sub _ASM_IA64_IO_H () {1;}' unless defined(&_ASM_IA64_IO_H);
    eval 'sub __SLOW_DOWN_IO () { &do { }  &while (0);}' unless defined(&__SLOW_DOWN_IO);
    eval 'sub SLOW_DOWN_IO () { &do { }  &while (0);}' unless defined(&SLOW_DOWN_IO);
    eval 'sub __IA64_UNCACHED_OFFSET () {0xc000000000000000;}' unless defined(&__IA64_UNCACHED_OFFSET);
    eval 'sub IO_SPACE_LIMIT () {0xffffffffffffffff;}' unless defined(&IO_SPACE_LIMIT);
    eval 'sub MAX_IO_SPACES () {16;}' unless defined(&MAX_IO_SPACES);
    eval 'sub IO_SPACE_BITS () {24;}' unless defined(&IO_SPACE_BITS);
    eval 'sub IO_SPACE_SIZE () {(1 <<  &IO_SPACE_BITS);}' unless defined(&IO_SPACE_SIZE);
    eval 'sub IO_SPACE_NR {
        local($port) = @_;
	    eval q((($port) >>  &IO_SPACE_BITS));
    }' unless defined(&IO_SPACE_NR);
    eval 'sub IO_SPACE_BASE {
        local($space) = @_;
	    eval q((($space) <<  &IO_SPACE_BITS));
    }' unless defined(&IO_SPACE_BASE);
    eval 'sub IO_SPACE_PORT {
        local($port) = @_;
	    eval q((($port) & ( &IO_SPACE_SIZE - 1)));
    }' unless defined(&IO_SPACE_PORT);
    eval 'sub IO_SPACE_SPARSE_ENCODING {
        local($p) = @_;
	    eval q((((($p) >> 2) << 12) | ($p & 0xfff)));
    }' unless defined(&IO_SPACE_SPARSE_ENCODING);
    if(defined(&__KERNEL__)) {
	require 'asm/intrinsics.ph';
	require 'asm/machvec.ph';
	require 'asm/page.ph';
	require 'asm/system.ph';
	eval 'sub phys_to_virt {
	    local($address) = @_;
    	    eval q({ ( &void *) ($address +  &PAGE_OFFSET); });
	}' unless defined(&phys_to_virt);
	eval 'sub ARCH_HAS_VALID_PHYS_ADDR_RANGE () {1;}' unless defined(&ARCH_HAS_VALID_PHYS_ADDR_RANGE);
	eval 'sub bus_to_virt () { &phys_to_virt;}' unless defined(&bus_to_virt);
	eval 'sub virt_to_bus () { &virt_to_phys;}' unless defined(&virt_to_bus);
	eval 'sub page_to_bus () { &page_to_phys;}' unless defined(&page_to_bus);
    }
    eval 'sub __ia64_mf_a () {
        eval q( &ia64_mfa());
    }' unless defined(&__ia64_mf_a);
    eval 'sub __ia64_get_io_port_base {
        local($void) = @_;
	    eval q({ my $ia64_iobase;  $ia64_iobase; });
    }' unless defined(&__ia64_get_io_port_base);
    eval 'sub __ia64_mk_io_addr {
        local($port) = @_;
	    eval q({ \'struct io_space\' * &space; my $offset;  &space =  $io_space[ &IO_SPACE_NR($port)]; $port =  &IO_SPACE_PORT($port);  &if ( ($space->{sparse}))  $offset =  &IO_SPACE_SPARSE_ENCODING($port);  &else  $offset = $port; ( &void *) ( ($space->{mmio_base}) |  $offset); });
    }' unless defined(&__ia64_mk_io_addr);
    eval 'sub __ia64_inb () { &___ia64_inb;}' unless defined(&__ia64_inb);
    eval 'sub __ia64_inw () { &___ia64_inw;}' unless defined(&__ia64_inw);
    eval 'sub __ia64_inl () { &___ia64_inl;}' unless defined(&__ia64_inl);
    eval 'sub __ia64_outb () { &___ia64_outb;}' unless defined(&__ia64_outb);
    eval 'sub __ia64_outw () { &___ia64_outw;}' unless defined(&__ia64_outw);
    eval 'sub __ia64_outl () { &___ia64_outl;}' unless defined(&__ia64_outl);
    eval 'sub __ia64_readb () { &___ia64_readb;}' unless defined(&__ia64_readb);
    eval 'sub __ia64_readw () { &___ia64_readw;}' unless defined(&__ia64_readw);
    eval 'sub __ia64_readl () { &___ia64_readl;}' unless defined(&__ia64_readl);
    eval 'sub __ia64_readq () { &___ia64_readq;}' unless defined(&__ia64_readq);
    eval 'sub __ia64_readb_relaxed () { &___ia64_readb;}' unless defined(&__ia64_readb_relaxed);
    eval 'sub __ia64_readw_relaxed () { &___ia64_readw;}' unless defined(&__ia64_readw_relaxed);
    eval 'sub __ia64_readl_relaxed () { &___ia64_readl;}' unless defined(&__ia64_readl_relaxed);
    eval 'sub __ia64_readq_relaxed () { &___ia64_readq;}' unless defined(&__ia64_readq_relaxed);
    eval 'sub __ia64_writeb () { &___ia64_writeb;}' unless defined(&__ia64_writeb);
    eval 'sub __ia64_writew () { &___ia64_writew;}' unless defined(&__ia64_writew);
    eval 'sub __ia64_writel () { &___ia64_writel;}' unless defined(&__ia64_writel);
    eval 'sub __ia64_writeq () { &___ia64_writeq;}' unless defined(&__ia64_writeq);
    eval 'sub ___ia64_inw {
        local($port) = @_;
	    eval q({  &volatile my $short * &addr =  &__ia64_mk_io_addr($port); my $ret;  $ret = * &addr;  &__ia64_mf_a();  $ret; });
    }' unless defined(&___ia64_inw);
    eval 'sub ___ia64_inl {
        local($port) = @_;
	    eval q({  &volatile my $int * &addr =  &__ia64_mk_io_addr($port); my $ret;  $ret = * &addr;  &__ia64_mf_a();  $ret; });
    }' unless defined(&___ia64_inl);
    eval 'sub ___ia64_outb {
        local($val,$port) = @_;
	    eval q({  &volatile my $char * &addr =  &__ia64_mk_io_addr($port); * &addr = $val;  &__ia64_mf_a(); });
    }' unless defined(&___ia64_outb);
    eval 'sub ___ia64_outw {
        local($val,$port) = @_;
	    eval q({  &volatile my $short * &addr =  &__ia64_mk_io_addr($port); * &addr = $val;  &__ia64_mf_a(); });
    }' unless defined(&___ia64_outw);
    eval 'sub ___ia64_outl {
        local($val,$port) = @_;
	    eval q({  &volatile my $int * &addr =  &__ia64_mk_io_addr($port); * &addr = $val;  &__ia64_mf_a(); });
    }' unless defined(&___ia64_outl);
    eval 'sub __insb {
        local($port,$dst,$count) = @_;
	    eval q({ my $char * &dp = $dst;  &while ($count--) * &dp++ =  &platform_inb($port); });
    }' unless defined(&__insb);
    eval 'sub __insw {
        local($port,$dst,$count) = @_;
	    eval q({ my $short * &dp = $dst;  &while ($count--) * &dp++ =  &platform_inw($port); });
    }' unless defined(&__insw);
    eval 'sub __insl {
        local($port,$dst,$count) = @_;
	    eval q({ my $int * &dp = $dst;  &while ($count--) * &dp++ =  &platform_inl($port); });
    }' unless defined(&__insl);
    eval 'sub __outsb {
        local($port,$src,$count) = @_;
	    eval q({  &const my $char * &sp = $src;  &while ($count--)  &platform_outb(* &sp++, $port); });
    }' unless defined(&__outsb);
    eval 'sub __outsw {
        local($port,$src,$count) = @_;
	    eval q({  &const my $short * &sp = $src;  &while ($count--)  &platform_outw(* &sp++, $port); });
    }' unless defined(&__outsw);
    eval 'sub __outsl {
        local($port,$src,$count) = @_;
	    eval q({  &const my $int * &sp = $src;  &while ($count--)  &platform_outl(* &sp++, $port); });
    }' unless defined(&__outsl);
    eval 'sub __inb () { &platform_inb;}' unless defined(&__inb);
    eval 'sub __inw () { &platform_inw;}' unless defined(&__inw);
    eval 'sub __inl () { &platform_inl;}' unless defined(&__inl);
    eval 'sub __outb () { &platform_outb;}' unless defined(&__outb);
    eval 'sub __outw () { &platform_outw;}' unless defined(&__outw);
    eval 'sub __outl () { &platform_outl;}' unless defined(&__outl);
    eval 'sub inb {
        local($p) = @_;
	    eval q( &__inb($p));
    }' unless defined(&inb);
    eval 'sub inw {
        local($p) = @_;
	    eval q( &__inw($p));
    }' unless defined(&inw);
    eval 'sub inl {
        local($p) = @_;
	    eval q( &__inl($p));
    }' unless defined(&inl);
    eval 'sub insb {
        local($p,$d,$c) = @_;
	    eval q( &__insb($p,$d,$c));
    }' unless defined(&insb);
    eval 'sub insw {
        local($p,$d,$c) = @_;
	    eval q( &__insw($p,$d,$c));
    }' unless defined(&insw);
    eval 'sub insl {
        local($p,$d,$c) = @_;
	    eval q( &__insl($p,$d,$c));
    }' unless defined(&insl);
    eval 'sub outb {
        local($v,$p) = @_;
	    eval q( &__outb($v,$p));
    }' unless defined(&outb);
    eval 'sub outw {
        local($v,$p) = @_;
	    eval q( &__outw($v,$p));
    }' unless defined(&outw);
    eval 'sub outl {
        local($v,$p) = @_;
	    eval q( &__outl($v,$p));
    }' unless defined(&outl);
    eval 'sub outsb {
        local($p,$s,$c) = @_;
	    eval q( &__outsb($p,$s,$c));
    }' unless defined(&outsb);
    eval 'sub outsw {
        local($p,$s,$c) = @_;
	    eval q( &__outsw($p,$s,$c));
    }' unless defined(&outsw);
    eval 'sub outsl {
        local($p,$s,$c) = @_;
	    eval q( &__outsl($p,$s,$c));
    }' unless defined(&outsl);
    eval 'sub ___ia64_readw {
        local($addr) = @_;
	    eval q({ *( &volatile my $short *)$addr; });
    }' unless defined(&___ia64_readw);
    eval 'sub ___ia64_readl {
        local($addr) = @_;
	    eval q({ *( &volatile my $int *) $addr; });
    }' unless defined(&___ia64_readl);
    eval 'sub ___ia64_readq {
        local($addr) = @_;
	    eval q({ *( &volatile my $long *) $addr; });
    }' unless defined(&___ia64_readq);
    eval 'sub __writeb {
        local($val,$addr) = @_;
	    eval q({ *( &volatile my $char *) $addr = $val; });
    }' unless defined(&__writeb);
    eval 'sub __writew {
        local($val,$addr) = @_;
	    eval q({ *( &volatile my $short *) $addr = $val; });
    }' unless defined(&__writew);
    eval 'sub __writel {
        local($val,$addr) = @_;
	    eval q({ *( &volatile my $int *) $addr = $val; });
    }' unless defined(&__writel);
    eval 'sub __writeq {
        local($val,$addr) = @_;
	    eval q({ *( &volatile my $long *) $addr = $val; });
    }' unless defined(&__writeq);
    eval 'sub __readb () { &platform_readb;}' unless defined(&__readb);
    eval 'sub __readw () { &platform_readw;}' unless defined(&__readw);
    eval 'sub __readl () { &platform_readl;}' unless defined(&__readl);
    eval 'sub __readq () { &platform_readq;}' unless defined(&__readq);
    eval 'sub __readb_relaxed () { &platform_readb_relaxed;}' unless defined(&__readb_relaxed);
    eval 'sub __readw_relaxed () { &platform_readw_relaxed;}' unless defined(&__readw_relaxed);
    eval 'sub __readl_relaxed () { &platform_readl_relaxed;}' unless defined(&__readl_relaxed);
    eval 'sub __readq_relaxed () { &platform_readq_relaxed;}' unless defined(&__readq_relaxed);
    eval 'sub readb {
        local($a) = @_;
	    eval q( &__readb(( &void *)($a)));
    }' unless defined(&readb);
    eval 'sub readw {
        local($a) = @_;
	    eval q( &__readw(( &void *)($a)));
    }' unless defined(&readw);
    eval 'sub readl {
        local($a) = @_;
	    eval q( &__readl(( &void *)($a)));
    }' unless defined(&readl);
    eval 'sub readq {
        local($a) = @_;
	    eval q( &__readq(( &void *)($a)));
    }' unless defined(&readq);
    eval 'sub readb_relaxed {
        local($a) = @_;
	    eval q( &__readb_relaxed(( &void *)($a)));
    }' unless defined(&readb_relaxed);
    eval 'sub readw_relaxed {
        local($a) = @_;
	    eval q( &__readw_relaxed(( &void *)($a)));
    }' unless defined(&readw_relaxed);
    eval 'sub readl_relaxed {
        local($a) = @_;
	    eval q( &__readl_relaxed(( &void *)($a)));
    }' unless defined(&readl_relaxed);
    eval 'sub readq_relaxed {
        local($a) = @_;
	    eval q( &__readq_relaxed(( &void *)($a)));
    }' unless defined(&readq_relaxed);
    eval 'sub __raw_readb () { &readb;}' unless defined(&__raw_readb);
    eval 'sub __raw_readw () { &readw;}' unless defined(&__raw_readw);
    eval 'sub __raw_readl () { &readl;}' unless defined(&__raw_readl);
    eval 'sub __raw_readq () { &readq;}' unless defined(&__raw_readq);
    eval 'sub __raw_readb_relaxed () { &readb_relaxed;}' unless defined(&__raw_readb_relaxed);
    eval 'sub __raw_readw_relaxed () { &readw_relaxed;}' unless defined(&__raw_readw_relaxed);
    eval 'sub __raw_readl_relaxed () { &readl_relaxed;}' unless defined(&__raw_readl_relaxed);
    eval 'sub __raw_readq_relaxed () { &readq_relaxed;}' unless defined(&__raw_readq_relaxed);
    eval 'sub writeb {
        local($v,$a) = @_;
	    eval q( &__writeb(($v), ( &void *) ($a)));
    }' unless defined(&writeb);
    eval 'sub writew {
        local($v,$a) = @_;
	    eval q( &__writew(($v), ( &void *) ($a)));
    }' unless defined(&writew);
    eval 'sub writel {
        local($v,$a) = @_;
	    eval q( &__writel(($v), ( &void *) ($a)));
    }' unless defined(&writel);
    eval 'sub writeq {
        local($v,$a) = @_;
	    eval q( &__writeq(($v), ( &void *) ($a)));
    }' unless defined(&writeq);
    eval 'sub __raw_writeb () { &writeb;}' unless defined(&__raw_writeb);
    eval 'sub __raw_writew () { &writew;}' unless defined(&__raw_writew);
    eval 'sub __raw_writel () { &writel;}' unless defined(&__raw_writel);
    eval 'sub __raw_writeq () { &writeq;}' unless defined(&__raw_writeq);
    unless(defined(&inb_p)) {
	eval 'sub inb_p () { &inb;}' unless defined(&inb_p);
    }
    unless(defined(&inw_p)) {
	eval 'sub inw_p () { &inw;}' unless defined(&inw_p);
    }
    unless(defined(&inl_p)) {
	eval 'sub inl_p () { &inl;}' unless defined(&inl_p);
    }
    unless(defined(&outb_p)) {
	eval 'sub outb_p () { &outb;}' unless defined(&outb_p);
    }
    unless(defined(&outw_p)) {
	eval 'sub outw_p () { &outw;}' unless defined(&outw_p);
    }
    unless(defined(&outl_p)) {
	eval 'sub outl_p () { &outl;}' unless defined(&outl_p);
    }
    eval 'sub iounmap {
        local($addr) = @_;
	    eval q({ });
    }' unless defined(&iounmap);
    eval 'sub ioremap_nocache {
        local($o,$s) = @_;
	    eval q( &ioremap($o,$s));
    }' unless defined(&ioremap_nocache);
    if(defined(&__KERNEL__)) {
	eval 'sub memcpy_fromio {
	    local($to,$from,$len) = @_;
    	    eval q( &__ia64_memcpy_fromio(,($from),($len)));
	}' unless defined(&memcpy_fromio);
	eval 'sub memcpy_toio {
	    local($to,$from,$len) = @_;
    	    eval q( &__ia64_memcpy_toio(($to),($from),($len)));
	}' unless defined(&memcpy_toio);
	eval 'sub memset_io {
	    local($addr,$c,$len) = @_;
    	    eval q( &__ia64_memset_c_io(($addr),0x101010101010101*( &u8)($c),($len)));
	}' unless defined(&memset_io);
	eval 'sub dma_cache_inv {
	    local($_start,$_size) = @_;
    	    eval q( &do { }  &while (0));
	}' unless defined(&dma_cache_inv);
	eval 'sub dma_cache_wback {
	    local($_start,$_size) = @_;
    	    eval q( &do { }  &while (0));
	}' unless defined(&dma_cache_wback);
	eval 'sub dma_cache_wback_inv {
	    local($_start,$_size) = @_;
    	    eval q( &do { }  &while (0));
	}' unless defined(&dma_cache_wback_inv);
    }
    if(1) {
	eval 'sub BIO_VMERGE_BOUNDARY () {0;}' unless defined(&BIO_VMERGE_BOUNDARY);
    } else {
	eval 'sub BIO_VMERGE_BOUNDARY () {( &ia64_max_iommu_merge_mask + 1);}' unless defined(&BIO_VMERGE_BOUNDARY);
    }
}
1;
