require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_IA64_MMU_CONTEXT_H)) {
    eval 'sub _ASM_IA64_MMU_CONTEXT_H () {1;}' unless defined(&_ASM_IA64_MMU_CONTEXT_H);
    eval 'sub IA64_REGION_ID_KERNEL () {0;}' unless defined(&IA64_REGION_ID_KERNEL);
    eval 'sub ia64_rid {
        local($ctx,$addr) = @_;
	    eval q(((($ctx) << 3) | ($addr >> 61)));
    }' unless defined(&ia64_rid);
    unless(defined(&__ASSEMBLY__)) {
	require 'linux/compiler.ph';
	require 'linux/percpu.ph';
	require 'linux/sched.ph';
	require 'linux/spinlock.ph';
	require 'asm/processor.ph';
	eval 'sub MMU_CONTEXT_DEBUG () {0;}' unless defined(&MMU_CONTEXT_DEBUG);
	if((defined(&MMU_CONTEXT_DEBUG) ? &MMU_CONTEXT_DEBUG : 0)) {
	    require 'ia64intrin.ph';
	    eval 'sub MMU_TRACE {
	        local($_op,$_cpu,$_mm,$_ctx) = @_;
    		eval q( &do { \'int\'  &i =  &__sync_fetch_and_add( &mmu_tbuf_index, 1) %  &ARRAY_SIZE( &mmu_tbuf); \'struct mmu_trace_entry\'  &e;  ($e->{op}) = ($_op);  ($e->{cpu}) = ($_cpu);  ($e->{mm}) = ($_mm);  ($e->{context}) = ($_ctx);  $mmu_tbuf[ &i] =  &e; }  &while (0));
	    }' unless defined(&MMU_TRACE);
	} else {
	    eval 'sub MMU_TRACE {
	        local($op,$cpu,$mm,$ctx) = @_;
    		eval q( &do { ; }  &while (0));
	    }' unless defined(&MMU_TRACE);
	}
	eval 'sub enter_lazy_tlb {
	    local($mm,$tsk) = @_;
    	    eval q({ });
	}' unless defined(&enter_lazy_tlb);
	eval 'sub get_mmu_context {
	    local($mm) = @_;
    	    eval q({ my $flags;  &mm_context_t  &context =  ($mm->{context});  &if ( &context)  &context;  &spin_lock_irqsave( ($ia64_ctx->{lock}),  $flags); {  &context =  ($mm->{context});  &if ( &context == 0) {  &cpus_clear( ($mm->{cpu_vm_mask}));  &if ( ($ia64_ctx->{next}) >=  ($ia64_ctx->{limit}))  &wrap_mmu_context($mm);  ($mm->{context}) =  &context =  ($ia64_ctx->{next})++; } }  &spin_unlock_irqrestore( ($ia64_ctx->{lock}),  $flags);  &context; });
	}' unless defined(&get_mmu_context);
	eval 'sub destroy_context {
	    local($mm) = @_;
    	    eval q({  &MMU_TRACE(ord(\'D\'),  &smp_processor_id(), $mm,  ($mm->{context})); });
	}' unless defined(&destroy_context);
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub reload_context {
	    local($context) = @_;
    	    eval q({ my $rid; my $rid_incr = 0; my $rr0,  &rr1,  &rr2,  &rr3,  &rr4,  &old_rr4;  &old_rr4 =  &ia64_get_rr(0x8000000000000000);  $rid = $context << 3;  $rid_incr = 1<< 8;  $rr0 = ( $rid << 8) | ( &PAGE_SHIFT << 2) | 1;  &rr1 =  $rr0 + 1* $rid_incr;  &rr2 =  $rr0 + 2* $rid_incr;  &rr3 =  $rr0 + 3* $rid_incr;  &rr4 =  $rr0 + 4* $rid_incr;  &ia64_set_rr(0x,  $rr0);  &ia64_set_rr(0x2000000000000000,  &rr1);  &ia64_set_rr(0x4000000000000000,  &rr2);  &ia64_set_rr(0x6000000000000000,  &rr3);  &ia64_set_rr(0x8000000000000000,  &rr4);  &ia64_srlz_i(); });
	}' unless defined(&reload_context);
	eval 'sub activate_context {
	    local($mm) = @_;
    	    eval q({  &mm_context_t  &context;  &do {  &context =  &get_mmu_context($mm);  &MMU_TRACE(ord(\'A\', smp_processor_id(), mm, context); 		if (!cpu_isset(smp_processor_id(), mm->cpu_vm_mask)) 			cpu_set(smp_processor_id(), mm->cpu_vm_mask); 		reload_context(context); 		MMU_TRACE(\'a\'),  &smp_processor_id(), $mm,  &context); }  &while ( &unlikely( &context !=  ($mm->{context}))); });
	}' unless defined(&activate_context);
	eval 'sub deactivate_mm {
	    local($tsk,$mm) = @_;
    	    eval q( &do {  &MMU_TRACE(ord(\'d\'),  &smp_processor_id(), $mm,  ($mm->{context})); }  &while (0));
	}' unless defined(&deactivate_mm);
	eval 'sub switch_mm {
	    local($prev_mm,$next_mm,$next_task) = @_;
    	    eval q( &activate_mm($prev_mm, $next_mm));
	}' unless defined(&switch_mm);
    }
}
1;
