require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_IA64_PAGE_H)) {
    eval 'sub _ASM_IA64_PAGE_H () {1;}' unless defined(&_ASM_IA64_PAGE_H);
    require 'linux/config.ph';
    require 'asm/intrinsics.ph';
    require 'asm/types.ph';
    if(defined( &CONFIG_IA64_PAGE_SIZE_4KB)) {
	eval 'sub PAGE_SHIFT () {12;}' unless defined(&PAGE_SHIFT);
    }
 elsif(defined( &CONFIG_IA64_PAGE_SIZE_8KB)) {
	eval 'sub PAGE_SHIFT () {13;}' unless defined(&PAGE_SHIFT);
    }
 elsif(defined( &CONFIG_IA64_PAGE_SIZE_16KB)) {
	eval 'sub PAGE_SHIFT () {14;}' unless defined(&PAGE_SHIFT);
    }
 elsif(defined( &CONFIG_IA64_PAGE_SIZE_64KB)) {
	eval 'sub PAGE_SHIFT () {16;}' unless defined(&PAGE_SHIFT);
    } else {
	die("Unsupported\ page\ size\!");
    }
    eval 'sub PAGE_SIZE () {( &__IA64_UL_CONST(1) <<  &PAGE_SHIFT);}' unless defined(&PAGE_SIZE);
    eval 'sub PAGE_MASK () {(~( &PAGE_SIZE - 1));}' unless defined(&PAGE_MASK);
    eval 'sub PAGE_ALIGN {
        local($addr) = @_;
	    eval q(((($addr) +  &PAGE_SIZE - 1) &  &PAGE_MASK));
    }' unless defined(&PAGE_ALIGN);
    eval 'sub PERCPU_PAGE_SHIFT () {16;}' unless defined(&PERCPU_PAGE_SHIFT);
    eval 'sub PERCPU_PAGE_SIZE () {( &__IA64_UL_CONST(1) <<  &PERCPU_PAGE_SHIFT);}' unless defined(&PERCPU_PAGE_SIZE);
    eval 'sub RGN_MAP_LIMIT () {((1 << (4* &PAGE_SHIFT - 12)) -  &PAGE_SIZE);}' unless defined(&RGN_MAP_LIMIT);
    if(defined(&CONFIG_HUGETLB_PAGE)) {
	eval 'sub REGION_HPAGE () {(4);}' unless defined(&REGION_HPAGE);
	eval 'sub REGION_SHIFT () {61;}' unless defined(&REGION_SHIFT);
	eval 'sub HPAGE_REGION_BASE () {( &REGION_HPAGE <<  &REGION_SHIFT);}' unless defined(&HPAGE_REGION_BASE);
	eval 'sub HPAGE_SHIFT () { &hpage_shift;}' unless defined(&HPAGE_SHIFT);
	eval 'sub HPAGE_SHIFT_DEFAULT () {28;}' unless defined(&HPAGE_SHIFT_DEFAULT);
	eval 'sub HPAGE_SIZE () {( &__IA64_UL_CONST(1) <<  &HPAGE_SHIFT);}' unless defined(&HPAGE_SIZE);
	eval 'sub HPAGE_MASK () {(~( &HPAGE_SIZE - 1));}' unless defined(&HPAGE_MASK);
	eval 'sub HAVE_ARCH_HUGETLB_UNMAPPED_AREA () {1;}' unless defined(&HAVE_ARCH_HUGETLB_UNMAPPED_AREA);
	eval 'sub ARCH_HAS_HUGEPAGE_ONLY_RANGE () {1;}' unless defined(&ARCH_HAS_HUGEPAGE_ONLY_RANGE);
    }
    if(defined(&__ASSEMBLY__)) {
	eval 'sub __pa {
	    local($x) = @_;
    	    eval q((($x) -  &PAGE_OFFSET));
	}' unless defined(&__pa);
	eval 'sub __va {
	    local($x) = @_;
    	    eval q((($x) +  &PAGE_OFFSET));
	}' unless defined(&__va);
    } else {
	if(defined(&__KERNEL__)) {
	    eval 'sub STRICT_MM_TYPECHECKS () {1;}' unless defined(&STRICT_MM_TYPECHECKS);
	    eval 'sub clear_user_page {
	        local($addr, $vaddr, $page) = @_;
    		eval q( &do {  &clear_page($addr);  &flush_dcache_page($page); }  &while (0));
	    }' unless defined(&clear_user_page);
	    eval 'sub copy_user_page {
	        local($to, $from, $vaddr, $page) = @_;
    		eval q( &do {  &copy_page(($to), ($from));  &flush_dcache_page($page); }  &while (0));
	    }' unless defined(&copy_user_page);
	    eval 'sub virt_addr_valid {
	        local($kaddr) = @_;
    		eval q( &pfn_valid( &__pa($kaddr) >>  &PAGE_SHIFT));
	    }' unless defined(&virt_addr_valid);
	    if(defined(&CONFIG_VIRTUAL_MEM_MAP)) {
	    } else {
		eval 'sub ia64_pfn_valid {
		    local($pfn) = @_;
    		    eval q(1);
		}' unless defined(&ia64_pfn_valid);
	    }
	    unless(defined(&CONFIG_DISCONTIGMEM)) {
		eval 'sub pfn_valid {
		    local($pfn) = @_;
    		    eval q(((($pfn) <  &max_mapnr)  &&  &ia64_pfn_valid($pfn)));
		}' unless defined(&pfn_valid);
		eval 'sub page_to_pfn {
		    local($page) = @_;
    		    eval q(( ($page -  &mem_map)));
		}' unless defined(&page_to_pfn);
		eval 'sub pfn_to_page {
		    local($pfn) = @_;
    		    eval q(( &mem_map + ($pfn)));
		}' unless defined(&pfn_to_page);
	    }
	    eval 'sub page_to_phys {
	        local($page) = @_;
    		eval q(( &page_to_pfn($page) <<  &PAGE_SHIFT));
	    }' unless defined(&page_to_phys);
	    eval 'sub virt_to_page {
	        local($kaddr) = @_;
    		eval q( &pfn_to_page( &__pa($kaddr) >>  &PAGE_SHIFT));
	    }' unless defined(&virt_to_page);
	    eval 'sub __pa {
	        local($x) = @_;
    		eval q(({ &ia64_va  &_v;  ($_v->{l}) = ($x);  ($_v->{f}->{reg}) = 0;  ($_v->{l});}));
	    }' unless defined(&__pa);
	    eval 'sub __va {
	        local($x) = @_;
    		eval q(({ &ia64_va  &_v;  ($_v->{l}) = ($x);  ($_v->{f}->{reg}) = -1;  ($_v->{p});}));
	    }' unless defined(&__va);
	    eval 'sub REGION_NUMBER {
	        local($x) = @_;
    		eval q(({ &ia64_va  &_v;  ($_v->{l}) = ($x);  ($_v->{f}->{reg});}));
	    }' unless defined(&REGION_NUMBER);
	    eval 'sub REGION_OFFSET {
	        local($x) = @_;
    		eval q(({ &ia64_va  &_v;  ($_v->{l}) = ($x);  ($_v->{f}->{off});}));
	    }' unless defined(&REGION_OFFSET);
	    eval 'sub REGION_SIZE () { &REGION_NUMBER(1);}' unless defined(&REGION_SIZE);
	    eval 'sub REGION_KERNEL () {7;}' unless defined(&REGION_KERNEL);
	    if(defined(&CONFIG_HUGETLB_PAGE)) {
		eval 'sub htlbpage_to_page {
		    local($x) = @_;
    		    eval q((( &REGION_NUMBER($x) << 61) | ( &REGION_OFFSET($x) >> ( &HPAGE_SHIFT- &PAGE_SHIFT))));
		}' unless defined(&htlbpage_to_page);
		eval 'sub HUGETLB_PAGE_ORDER () {( &HPAGE_SHIFT -  &PAGE_SHIFT);}' unless defined(&HUGETLB_PAGE_ORDER);
		eval 'sub is_hugepage_only_range {
		    local($addr, $len) = @_;
    		    eval q(( &REGION_NUMBER($addr) ==  &REGION_HPAGE  &&  &REGION_NUMBER(($addr)+($len)) ==  &REGION_HPAGE));
		}' unless defined(&is_hugepage_only_range);
	    }
	    eval 'sub get_order {
	        local($size) = @_;
    		eval q({ my $d = $size - 1; my $order;  $order =  &ia64_getf_exp( $d);  $order =  $order -  &PAGE_SHIFT - 0xffff + 1;  &if ( $order < 0)  $order = 0;  $order; });
	    }' unless defined(&get_order);
	}
    }
    if(defined(&STRICT_MM_TYPECHECKS)) {
	eval 'sub pte_val {
	    local($x) = @_;
    	    eval q((($x). &pte));
	}' unless defined(&pte_val);
	eval 'sub pmd_val {
	    local($x) = @_;
    	    eval q((($x). &pmd));
	}' unless defined(&pmd_val);
	eval 'sub pgd_val {
	    local($x) = @_;
    	    eval q((($x). &pgd));
	}' unless defined(&pgd_val);
	eval 'sub pgprot_val {
	    local($x) = @_;
    	    eval q((($x). &pgprot));
	}' unless defined(&pgprot_val);
	eval 'sub __pte {
	    local($x) = @_;
    	    eval q((( &pte_t) { ($x) } ));
	}' unless defined(&__pte);
	eval 'sub __pgprot {
	    local($x) = @_;
    	    eval q((( &pgprot_t) { ($x) } ));
	}' unless defined(&__pgprot);
    } else {
	unless(defined(&__ASSEMBLY__)) {
	}
	eval 'sub pte_val {
	    local($x) = @_;
    	    eval q(($x));
	}' unless defined(&pte_val);
	eval 'sub pmd_val {
	    local($x) = @_;
    	    eval q(($x));
	}' unless defined(&pmd_val);
	eval 'sub pgd_val {
	    local($x) = @_;
    	    eval q(($x));
	}' unless defined(&pgd_val);
	eval 'sub pgprot_val {
	    local($x) = @_;
    	    eval q(($x));
	}' unless defined(&pgprot_val);
	eval 'sub __pte {
	    local($x) = @_;
    	    eval q(($x));
	}' unless defined(&__pte);
	eval 'sub __pgd {
	    local($x) = @_;
    	    eval q(($x));
	}' unless defined(&__pgd);
	eval 'sub __pgprot {
	    local($x) = @_;
    	    eval q(($x));
	}' unless defined(&__pgprot);
    }
    eval 'sub PAGE_OFFSET () {0xe000000000000000;}' unless defined(&PAGE_OFFSET);
    eval 'sub VM_DATA_DEFAULT_FLAGS () {( &VM_READ |  &VM_WRITE |  &VM_MAYREAD |  &VM_MAYWRITE |  &VM_MAYEXEC | ((( ($current->{personality}) &  &READ_IMPLIES_EXEC) != 0) ?  &VM_EXEC : 0));}' unless defined(&VM_DATA_DEFAULT_FLAGS);
}
1;
