require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_IA64_PGALLOC_H)) {
    eval 'sub _ASM_IA64_PGALLOC_H () {1;}' unless defined(&_ASM_IA64_PGALLOC_H);
    require 'linux/config.ph';
    require 'linux/compiler.ph';
    require 'linux/mm.ph';
    require 'linux/page-flags.ph';
    require 'linux/threads.ph';
    require 'asm/mmu_context.ph';
    require 'asm/processor.ph';
    eval 'sub pgd_quicklist () {( ($local_cpu_data->{pgd_quick}));}' unless defined(&pgd_quicklist);
    eval 'sub pmd_quicklist () {( ($local_cpu_data->{pmd_quick}));}' unless defined(&pmd_quicklist);
    eval 'sub pgtable_cache_size () {( ($local_cpu_data->{pgtable_cache_sz}));}' unless defined(&pgtable_cache_size);
    eval 'sub pgd_alloc_one_fast {
        local($mm) = @_;
	    eval q({ my $long * &ret =  &NULL;  &preempt_disable();  &ret =  &pgd_quicklist;  &if ( &likely( &ret !=  &NULL)) {  &pgd_quicklist = (* &ret);  $ret[0] = 0; -- &pgtable_cache_size; }  &else  &ret =  &NULL;  &preempt_enable(); ( &pgd_t *)  &ret; });
    }' unless defined(&pgd_alloc_one_fast);
    eval 'sub pgd_alloc {
        local($mm) = @_;
	    eval q({  &pgd_t * &pgd =  &pgd_alloc_one_fast($mm);  &if ( &unlikely( &pgd ==  &NULL)) {  &pgd = ( &pgd_t *) &__get_free_page( &GFP_KERNEL);  &if ( &likely( &pgd !=  &NULL))  &clear_page( &pgd); }  &pgd; });
    }' unless defined(&pgd_alloc);
    eval 'sub pgd_free {
        local($pgd) = @_;
	    eval q({  &preempt_disable(); *$pgd =  &pgd_quicklist;  &pgd_quicklist = $pgd; ++ &pgtable_cache_size;  &preempt_enable(); });
    }' unless defined(&pgd_free);
    eval 'sub pgd_populate {
        local($mm,$pgd_entry,$pmd) = @_;
	    eval q({  &pgd_val(*$pgd_entry) =  &__pa($pmd); });
    }' unless defined(&pgd_populate);
    eval 'sub pmd_alloc_one_fast {
        local($mm,$addr) = @_;
	    eval q({ my $long * &ret =  &NULL;  &preempt_disable();  &ret =  &pmd_quicklist;  &if ( &likely( &ret !=  &NULL)) {  &pmd_quicklist = (* &ret);  $ret[0] = 0; -- &pgtable_cache_size; }  &preempt_enable(); ( &pmd_t *) &ret; });
    }' unless defined(&pmd_alloc_one_fast);
    eval 'sub pmd_alloc_one {
        local($mm,$addr) = @_;
	    eval q({  &pmd_t * &pmd = ( &pmd_t *) &__get_free_page( &GFP_KERNEL| &__GFP_REPEAT);  &if ( &likely( &pmd !=  &NULL))  &clear_page( &pmd);  &pmd; });
    }' unless defined(&pmd_alloc_one);
    eval 'sub pmd_free {
        local($pmd) = @_;
	    eval q({  &preempt_disable(); *$pmd =  &pmd_quicklist;  &pmd_quicklist = $pmd; ++ &pgtable_cache_size;  &preempt_enable(); });
    }' unless defined(&pmd_free);
    eval 'sub __pmd_free_tlb {
        local($tlb, $pmd) = @_;
	    eval q( &pmd_free($pmd));
    }' unless defined(&__pmd_free_tlb);
    eval 'sub pmd_populate {
        local($mm,$pmd_entry,$pte) = @_;
	    eval q({  &pmd_val(*$pmd_entry) =  &page_to_phys($pte); });
    }' unless defined(&pmd_populate);
    eval 'sub pmd_populate_kernel {
        local($mm,$pmd_entry,$pte) = @_;
	    eval q({  &pmd_val(*$pmd_entry) =  &__pa($pte); });
    }' unless defined(&pmd_populate_kernel);
    eval 'sub pte_alloc_one {
        local($mm,$addr) = @_;
	    eval q({ \'struct page\' * &pte =  &alloc_pages( &GFP_KERNEL| &__GFP_REPEAT, 0);  &if ( &likely( &pte !=  &NULL))  &clear_page( &page_address( &pte));  &pte; });
    }' unless defined(&pte_alloc_one);
    eval 'sub pte_alloc_one_kernel {
        local($mm,$addr) = @_;
	    eval q({  &pte_t * &pte = ( &pte_t *) &__get_free_page( &GFP_KERNEL| &__GFP_REPEAT);  &if ( &likely( &pte !=  &NULL))  &clear_page( &pte);  &pte; });
    }' unless defined(&pte_alloc_one_kernel);
    eval 'sub pte_free {
        local($pte) = @_;
	    eval q({  &__free_page($pte); });
    }' unless defined(&pte_free);
    eval 'sub pte_free_kernel {
        local($pte) = @_;
	    eval q({  &free_page( $pte); });
    }' unless defined(&pte_free_kernel);
    eval 'sub __pte_free_tlb {
        local($tlb, $pte) = @_;
	    eval q( &tlb_remove_page(($tlb), ($pte)));
    }' unless defined(&__pte_free_tlb);
}
1;
