require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_IA64_UACCESS_H)) {
    eval 'sub _ASM_IA64_UACCESS_H () {1;}' unless defined(&_ASM_IA64_UACCESS_H);
    require 'linux/compiler.ph';
    require 'linux/errno.ph';
    require 'linux/sched.ph';
    require 'asm/intrinsics.ph';
    require 'asm/pgtable.ph';
    eval 'sub KERNEL_DS () {(( &mm_segment_t) { ~0 });}' unless defined(&KERNEL_DS);
    eval 'sub USER_DS () {(( &mm_segment_t) {  &TASK_SIZE-1});}' unless defined(&USER_DS);
    eval 'sub VERIFY_READ () {0;}' unless defined(&VERIFY_READ);
    eval 'sub VERIFY_WRITE () {1;}' unless defined(&VERIFY_WRITE);
    eval 'sub get_ds () {
        eval q(( &KERNEL_DS));
    }' unless defined(&get_ds);
    eval 'sub get_fs () {
        eval q(( &current_thread_info()-> &addr_limit));
    }' unless defined(&get_fs);
    eval 'sub set_fs {
        local($x) = @_;
	    eval q(( &current_thread_info()-> &addr_limit = ($x)));
    }' unless defined(&set_fs);
    eval 'sub segment_eq {
        local($a, $b) = @_;
	    eval q((($a). &seg == ($b). &seg));
    }' unless defined(&segment_eq);
    eval 'sub __access_ok {
        local($addr, $size, $segment) = @_;
	    eval q(( &likely( <= . &seg)  && (. &seg ==  ($KERNEL_DS->{seg})	 ||  &likely( &REGION_OFFSET( ($addr)) <  &RGN_MAP_LIMIT))));
    }' unless defined(&__access_ok);
    eval 'sub access_ok {
        local($type, $addr, $size) = @_;
	    eval q( &__access_ok(($addr), ($size),  &get_fs()));
    }' unless defined(&access_ok);
    eval 'sub verify_area {
        local($type,$addr,$size) = @_;
	    eval q({  &access_ok($type, $addr, $size) ? 0: - &EFAULT; });
    }' unless defined(&verify_area);
    eval 'sub put_user {
        local($x, $ptr) = @_;
	    eval q( &__put_user_check(( &__typeof__(*($ptr))) ($x), ($ptr), $sizeof{($ptr)},  &get_fs()));
    }' unless defined(&put_user);
    eval 'sub get_user {
        local($x, $ptr) = @_;
	    eval q( &__get_user_check(($x), ($ptr), $sizeof{($ptr)},  &get_fs()));
    }' unless defined(&get_user);
    eval 'sub __put_user {
        local($x, $ptr) = @_;
	    eval q( &__put_user_nocheck(( &__typeof__(*($ptr))) ($x), ($ptr), $sizeof{($ptr)}));
    }' unless defined(&__put_user);
    eval 'sub __get_user {
        local($x, $ptr) = @_;
	    eval q( &__get_user_nocheck(($x), ($ptr), $sizeof{($ptr)}));
    }' unless defined(&__get_user);
    if(defined(&ASM_SUPPORTED)) {
	eval 'sub __m {
	    local($x) = @_;
    	    eval q((*($x)));
	}' unless defined(&__m);
	eval 'sub __get_user_size {
	    local($val, $addr, $n, $err) = @_;
    	    eval q( &do {  &register  &long __gu_r8 asm (\\"r8\\") = 0;  &register  &long __gu_r9 asm (\\"r9\\");  &asm (\\"\\\\n[1:]\\\\tld\\"$n\\" %0=%2%P2\\\\t// %0 and %1 get overwritten by exception handler\\\\n\\" \\"\\\\t.xdata4 \\\\\\"__ex_table\\\\\\", 1b-., 1f-.+4\\\\n\\" \\"[1:]\\" : \\"=r\\"( &__gu_r9), \\"=r\\"( &__gu_r8) : \\"m\\"( &__m($addr)), \\"1\\"( &__gu_r8)); ($err) =  &__gu_r8; ($val) =  &__gu_r9; }  &while (0));
	}' unless defined(&__get_user_size);
	eval 'sub __put_user_size {
	    local($val, $addr, $n, $err) = @_;
    	    eval q( &do {  &register  &long __pu_r8 asm (\\"r8\\") = 0;  &asm  &volatile (\\"\\\\n[1:]\\\\tst\\"$n\\" %1=%r2%P1\\\\t// %0 gets overwritten by exception handler\\\\n\\" \\"\\\\t.xdata4 \\\\\\"__ex_table\\\\\\", 1b-., 1f-.\\\\n\\" \\"[1:]\\" : \\"=r\\"( &__pu_r8) : \\"m\\"( &__m($addr)), \\"rO\\"($val), \\"0\\"( &__pu_r8)); ($err) =  &__pu_r8; }  &while (0));
	}' unless defined(&__put_user_size);
    } else {
	eval 'sub RELOC_TYPE () {2;}' unless defined(&RELOC_TYPE);
	eval 'sub __get_user_size {
	    local($val, $addr, $n, $err) = @_;
    	    eval q( &do {  &__ld_user(\\"__ex_table\\", $addr, $n,  &RELOC_TYPE); ($err) =  &ia64_getreg( &_IA64_REG_R8); ($val) =  &ia64_getreg( &_IA64_REG_R9); }  &while (0));
	}' unless defined(&__get_user_size);
	eval 'sub __put_user_size {
	    local($val, $addr, $n, $err) = @_;
    	    eval q( &do {  &__st_user(\\"__ex_table\\", $addr, $n,  &RELOC_TYPE, ($val)); ($err) =  &ia64_getreg( &_IA64_REG_R8); }  &while (0));
	}' unless defined(&__put_user_size);
    }
    eval 'sub __do_get_user {
        local($check, $x, $ptr, $size, $segment) = @_;
	    eval q(({  &const  &__typeof__(*($ptr)) * &__gu_ptr = ($ptr);  &__typeof__ ($size)  &__gu_size = ; \'long __gu_err\' = - &EFAULT,  &__gu_val = 0;  &if (!$check ||  &__access_ok(  &__gu_ptr, $size, $segment))  &switch ( &__gu_size) {  &case 1:  &__get_user_size( &__gu_val,  &__gu_ptr, 1,  &__gu_err);  &break;  &case 2:  &__get_user_size( &__gu_val,  &__gu_ptr, 2,  &__gu_err);  &break;  &case 4:  &__get_user_size( &__gu_val,  &__gu_ptr, 4,  &__gu_err);  &break;  &case 8:  &__get_user_size( &__gu_val,  &__gu_ptr, 8,  &__gu_err);  &break;  &default:  &__get_user_unknown();  &break; } ($x) = ( &__typeof__(*( &__gu_ptr)))  &__gu_val;  &__gu_err; }));
    }' unless defined(&__do_get_user);
    eval 'sub __get_user_nocheck {
        local($x, $ptr, $size) = @_;
	    eval q( &__do_get_user(0, $x, $ptr, $size,  &KERNEL_DS));
    }' unless defined(&__get_user_nocheck);
    eval 'sub __get_user_check {
        local($x, $ptr, $size, $segment) = @_;
	    eval q( &__do_get_user(1, $x, $ptr, $size, $segment));
    }' unless defined(&__get_user_check);
    eval 'sub __do_put_user {
        local($check, $x, $ptr, $size, $segment) = @_;
	    eval q(({  &__typeof__ ($x)  &__pu_x = ($x);  &__typeof__ (*($ptr)) * &__pu_ptr = ($ptr);  &__typeof__ ($size)  &__pu_size = ; \'long __pu_err\' = - &EFAULT;  &if (!$check ||  &__access_ok(  &__pu_ptr,  &__pu_size, $segment))  &switch ( &__pu_size) {  &case 1:  &__put_user_size( &__pu_x,  &__pu_ptr, 1,  &__pu_err);  &break;  &case 2:  &__put_user_size( &__pu_x,  &__pu_ptr, 2,  &__pu_err);  &break;  &case 4:  &__put_user_size( &__pu_x,  &__pu_ptr, 4,  &__pu_err);  &break;  &case 8:  &__put_user_size( &__pu_x,  &__pu_ptr, 8,  &__pu_err);  &break;  &default:  &__put_user_unknown();  &break; }  &__pu_err; }));
    }' unless defined(&__do_put_user);
    eval 'sub __put_user_nocheck {
        local($x, $ptr, $size) = @_;
	    eval q( &__do_put_user(0, $x, $ptr, $size,  &KERNEL_DS));
    }' unless defined(&__put_user_nocheck);
    eval 'sub __put_user_check {
        local($x, $ptr, $size, $segment) = @_;
	    eval q( &__do_put_user(1, $x, $ptr, $size, $segment));
    }' unless defined(&__put_user_check);
    eval 'sub __copy_to_user {
        local($to, $from, $n) = @_;
	    eval q( &__copy_user(($to), ($from), ($n)));
    }' unless defined(&__copy_to_user);
    eval 'sub __copy_from_user {
        local($to, $from, $n) = @_;
	    eval q( &__copy_user(($to), ($from), ($n)));
    }' unless defined(&__copy_from_user);
    eval 'sub copy_to_user {
        local($to, $from, $n) = @_;
	    eval q( &__copy_tofrom_user(($to), ($from), ($n), 1));
    }' unless defined(&copy_to_user);
    eval 'sub copy_from_user {
        local($to, $from, $n) = @_;
	    eval q( &__copy_tofrom_user(($to), ($from), ($n), 0));
    }' unless defined(&copy_from_user);
    eval 'sub __copy_tofrom_user {
        local($to, $from, $n, $check_to) = @_;
	    eval q(({  &void * &__cu_to = ;  &const  &void * &__cu_from = ; \'long __cu_len\' = ;  &if ( &__access_ok( (($check_to) ?  &__cu_to :  &__cu_from),  &__cu_len,  &get_fs()))  &__cu_len =  &__copy_user( &__cu_to,  &__cu_from,  &__cu_len);  &__cu_len; }));
    }' unless defined(&__copy_tofrom_user);
    eval 'sub __copy_in_user {
        local($to, $from, $size) = @_;
	    eval q( &__copy_user(($to), ($from), ($size)));
    }' unless defined(&__copy_in_user);
    eval 'sub copy_in_user {
        local($to,$from,$n) = @_;
	    eval q({  &if ( &likely( &access_ok( &VERIFY_READ, $from, $n)  &&  &access_ok( &VERIFY_WRITE, $to, $n))) $n =  &__copy_user($to, $from, $n); $n; });
    }' unless defined(&copy_in_user);
    eval 'sub __clear_user {
        local($to, $n) = @_;
	    eval q( &__do_clear_user($to, $n));
    }' unless defined(&__clear_user);
    eval 'sub clear_user {
        local($to, $n) = @_;
	    eval q(({ \'unsigned long __cu_len\' = ;  &if ( &__access_ok( $to,  &__cu_len,  &get_fs()))  &__cu_len =  &__do_clear_user($to,  &__cu_len);  &__cu_len; }));
    }' unless defined(&clear_user);
    eval 'sub strncpy_from_user {
        local($to, $from, $n) = @_;
	    eval q(({  &const \'char\' *  &__sfu_from = ; \'long __sfu_ret\' = - &EFAULT;  &if ( &__access_ok(  &__sfu_from, 0,  &get_fs()))  &__sfu_ret =  &__strncpy_from_user(($to),  &__sfu_from, ($n));  &__sfu_ret; }));
    }' unless defined(&strncpy_from_user);
    eval 'sub strlen_user {
        local($str) = @_;
	    eval q(({  &const \'char\' * &__su_str = ; \'unsigned long __su_ret\' = 0;  &if ( &__access_ok(  &__su_str, 0,  &get_fs()))  &__su_ret =  &__strlen_user( &__su_str);  &__su_ret; }));
    }' unless defined(&strlen_user);
    eval 'sub strnlen_user {
        local($str, $len) = @_;
	    eval q(({  &const \'char\' * &__su_str = ; \'unsigned long __su_ret\' = 0;  &if ( &__access_ok(  &__su_str, 0,  &get_fs()))  &__su_ret =  &__strnlen_user( &__su_str, $len);  &__su_ret; }));
    }' unless defined(&strnlen_user);
    eval 'sub ARCH_HAS_SORT_EXTABLE () {1;}' unless defined(&ARCH_HAS_SORT_EXTABLE);
    eval 'sub ARCH_HAS_SEARCH_EXTABLE () {1;}' unless defined(&ARCH_HAS_SEARCH_EXTABLE);
    eval 'sub ia64_done_with_exception {
        local($regs) = @_;
	    eval q({  &const \'struct exception_table_entry\' * &e;  &e =  &search_exception_tables( ($regs->{cr_iip}) +  &ia64_psr($regs)-> &ri);  &if ( &e) {  &ia64_handle_exception($regs,  &e); 1; } 0; });
    }' unless defined(&ia64_done_with_exception);
}
1;
